#include <LiquidCrystal.h>

#define R1 10 
#define G1 9
#define B1 8

#define R2 7
#define G2 6
#define B2 5

#define R3 4
#define G3 3
#define B3 2

#define TRIG 12
#define ECHO 11

#define BUT 13

#define RS A0
#define E A1
#define D4 A2
#define D3 A3
#define D2 A4
#define D1 A5

int totalSum = 0;
long distTHR = 5;
int maxRoll = 5;
int bet = 0;
long dist = -1;

bool receiveBet = true;
bool detectedCoin = false;
bool buttonPressed = false;
int buttonCounter = 0;


LiquidCrystal lcd (RS, E, D4, D3, D2, D1);

void setup(){
	Serial.begin(9600); 
	pinMode (R1, OUTPUT);
	pinMode (G1, OUTPUT);
	pinMode (B1, OUTPUT);
	
	pinMode (R2, OUTPUT);
	pinMode (G2, OUTPUT);
	pinMode (B2, OUTPUT);
	
	pinMode (R2, OUTPUT);
	pinMode (G2, OUTPUT);
	pinMode (B2, OUTPUT);
	
	pinMode (BUT, INPUT);
	
	lcd.begin(16, 2);
}


void loop(){
  start:
  while(true){
    //cautam dupa bet
    printBank();
    long distance = readDistance(TRIG, ECHO);
    if(distance < distTHR){
      //am detectat o moneda
      detectedCoin = true;
      totalSum += 100;
      printBank();
      delay(3000);
    }
    if(digitalRead(BUT)){
      break;
    }
    //

  }
  bet_again:
  rollLights();
  generateOutcome(totalSum);
  if(totalSum == 0){
    goto start;
  }
  //printInstructions();
  long int afterBetTime = millis();
  bool waitInstruction = true;
  buttonCounter = 0;
  while(waitInstruction){
    if(millis() - afterBetTime >= 5000){
      //rebet
      while(true){
        printSafeCode();
        totalSum = 0;
        delay(3000);
        waitInstruction = false;
        break;
      }

    }
    if(digitalRead(BUT) && !buttonPressed){
      buttonCounter += 1;
      buttonPressed = false;
    }
    if(digitalRead(BUT) && buttonPressed){
      buttonPressed = true;
    }
    if(buttonCounter > 2){
      buttonCounter = 0;
      waitInstruction = false;
      goto bet_again;
    }
  }

  resetLED();

}

long readDistance(int ping, int echo){ 
	long duration, inches, cm, distance; 
	pinMode(ping, OUTPUT);
	digitalWrite(ping, LOW); 
	delayMicroseconds(2);
	digitalWrite(ping, HIGH);
	delayMicroseconds(10);
	digitalWrite(ping, LOW);
	pinMode(echo, INPUT);
	duration = pulseIn(echo, HIGH); 
	return duration /29 / 2;
}
	
void generateOutcome(int bet){
	/*
	3% - jackpot
	7% - triplu
	10% - dublu
	30% - bani
	50% - nimic
	*/
	int output = newrandom (0, 99);
	lcd.clear();
	lcd.setCursor(0, 0);
	if(between(output, 0, 3)){
		//jackpot
		lightRGBLed(R1, G1, B1, 255, 0, 255); 
		lightRGBLed(R2, G2, B2, 255, 0, 255);
		lightRGBLed(R3, G3, B3, 255, 0, 255); 
		totalSum += 5*bet;
		lcd.print("Jackpot: ");
		lcd.print(5*bet);
	} else if(between(output, 3, 10)){
		lightRGBLed(R1, G1, B1, 255, 255, 0);
		lightRGBLed(R2, G2, B2, 255, 255, 0); 
		lightRGBLed (R3, G3, B3, 255, 255, 0);
		totalSum += 3*bet;
		lcd.print("Triplu: ");
		lcd.print(3*bet);
	} else if(between(output, 10, 20)){
		lightRGBLed(R1, G1, B1, 0, 255, 0);
		lightRGBLed(R2, G2, B2, 0, 255, 0);
		lightRGBLed(R3, G3, B3, 0, 255, 0);
		totalSum += 2*bet;
		lcd.print("Dublu: ");
		lcd.print(2*bet);
	}else if(between(output, 20, 50)){
		lightRGBLed(R1, G1, B1, 0, 0, 255);
		lightRGBLed(R2, G2, B2, 0, 0, 255); 
		lightRGBLed(R3, G3, B3, 0, 0, 255);
		totalSum += bet;
		lcd.print("Egal: ");
		lcd.print(bet);
	}else{
		lightRGBLed(R1, G1, B1, 255, 0, 0); 
		lightRGBLed(R2, G2, B2, 255, 0, 0); 
		lightRGBLed(R3, G3, B3, 255, 0, 0); 
		lcd.print("Ai pierdut: ");
		lcd.print(bet);
    totalSum = 0;
	}
	delay(2000);
}

void rollLights(){
	for (int i = 0; i < newrandom(2, maxRoll); i++){
		lightRGBLed(R1, G1, B1, 255, 0, 0);
		lightRGBLed(R2, G2, B2, 0, 255, 0);
		lightRGBLed(R3, G3, B3, 0, 0, 255);
		delay(300);
		
		lightRGBLed(R1, G1, B1, 0, 255, 0); 
		lightRGBLed(R2, G2, B2, 0, 0, 255); 
		lightRGBLed(R3, G3, B3, 255, 0, 0); 
		delay(300);
		
		lightRGBLed(R1, G1, B1, 0, 0, 255); 
		lightRGBLed(R2, G2, B2, 255, 0, 0);
		lightRGBLed(R3, G3, B3, 0, 255, 0); 
		delay(300);
	}
}

bool between(int nr, int a, int b){ 
	return ((a <= nr) && (nr < b));
}

void resetLED(){
	lightRGBLed(R1, G1, B1, 0, 0, 0);
	lightRGBLed(R2, G2, B2, 0, 0, 0);
	lightRGBLed(R3, G3, B3, 0, 0, 0);
}

void lightRGBLed(int RPin, int GPin, int BPin, int RValue, int GValue, int BValue){ 
	analogWrite(RPin, RValue);
	analogWrite(GPin, GValue);
	analogWrite(BPin, BValue);
}

unsigned long newrandom(unsigned long howsmall, unsigned long howbig){
	return howsmall + random() % (howbig - howsmall);
}

void printBank(){
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Banca: ");
  lcd.print(totalSum);
  Serial.print("Banca: ");
  Serial.println(totalSum);
  delay(100);
}

void printSafeCode(){
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("PIN: 1234");
  delay(100);
}
